using System;
using System.Collections.Generic;
using System.Text;
using System.Linq;

using ArtOfTest.Common.UnitTesting;
using ArtOfTest.WebAii.Core;
using ArtOfTest.WebAii.Controls.HtmlControls;
using ArtOfTest.WebAii.Controls.HtmlControls.HtmlAsserts;
using ArtOfTest.WebAii.Design;
using ArtOfTest.WebAii.Design.Execution;
using ArtOfTest.WebAii.ObjectModel;
using ArtOfTest.WebAii.Silverlight;
using ArtOfTest.WebAii.Silverlight.UI;
using Telerik.TestingFramework.Controls.KendoUI;
using Telerik.WebAii.Controls.Html;
using Telerik.WebAii.Controls.Xaml;
using System.Windows.Forms;

using System.Runtime.Serialization;
using System.Threading;
using ArtOfTest.Common.Exceptions;


namespace Tabnav_Bugfix
{

    public class FG03_CheckTabNav : BaseWebAiiTest
    {
        #region [ Dynamic Pages Reference ]

        private Pages _pages;

        /// <summary>
        /// Gets the Pages object that has references
        /// to all the elements, frames or regions
        /// in this project.
        /// </summary>
        public Pages Pages
        {
            get
            {
                if (_pages == null)
                {
                    _pages = new Pages(Manager.Current);
                }
                return _pages;
            }
        }

        #endregion

        [CodedStep(@"Enter Tab in 'FG_Gap0Text'")]
        public void FG03_CheckTabNav_CodedStep()
        {
            // Enter text '' in 'FG_Gap0Text'
            Actions.SetText(Pages.HttpsWwwEdumaticonline.FG_Gap0Text, "");
            Pages.HttpsWwwEdumaticonline.FG_Gap0Text.ScrollToVisible(ArtOfTest.WebAii.Core.ScrollToVisibleType.ElementTopAtWindowTop);
            ActiveBrowser.Window.SetFocus();
            Pages.HttpsWwwEdumaticonline.FG_Gap0Text.MouseClick();
            System.Threading.Thread.Sleep(30000);
            Log.WriteLine(Actions.InvokeScript<string>("document.activeElement.id"));
            CheckFocus(Pages.HttpsWwwEdumaticonline.FG_Gap0Text);
            Manager.Desktop.KeyBoard.KeyPress(Keys.Tab, 500);
        }

        public void CheckFocus(HtmlInputText input)
        {
            int limit = 20;
            int counter = 0;
            bool tryAgain = true;
            string result = "";
            while(tryAgain){
                try{
                    result = Actions.InvokeScript<string>("document.activeElement.id");
                    tryAgain = false;
                    Log.WriteLine(result + "found in " + counter + "s");
                }catch(SerializationException e){
                    Thread.Sleep(1000);
                    counter++;
                    if (counter > limit)
                    {
                        throw new AssertException("Serialization error exceeds " + limit + "s", e);
                    }
                }
            }
            Log.WriteLine(result);
            Log.WriteLine("Expected: " + input.ID + " Actual: " + result);
            Assert.IsTrue(input.ID.Equals(result));
        }

        [CodedStep(@"Enter Tab in 'FG_Gap1Text'")]
        public void FG03_CheckTabNav_CodedStep1()
        {
            CheckFocus(Pages.HttpsWwwEdumaticonline.FG_Gap1Text);
            Manager.Desktop.KeyBoard.KeyPress(Keys.Tab, 500);
        }

        [CodedStep(@"Enter Tab in 'FG_Gap2Text'")]
        public void FG03_CheckTabNav_CodedStep2()
        {
            CheckFocus(Pages.HttpsWwwEdumaticonline.FG_Gap2Text);
            Manager.Desktop.KeyBoard.KeyPress(Keys.Tab, 500);
        }

        [CodedStep(@"Enter Tab in 'FG_Gap3Text'")]
        public void FG03_CheckTabNav_CodedStep3()
        {
            CheckFocus(Pages.HttpsWwwEdumaticonline.FG_Gap3Text);
            Manager.Desktop.KeyBoard.KeyPress(Keys.Tab, 500);
        }

        [CodedStep(@"Enter Tab in 'FG_Gap4Text'")]
        public void FG03_CheckTabNav_CodedStep4()
        {
            CheckFocus(Pages.HttpsWwwEdumaticonline.FG_Gap4Text);
        }
    }
}
